require 'presto/transformation/validator'
require 'veto'

module Presto
	class Transformation
		DEFAULT_BG = "#ffffff00"
		DEFAULT_FIT = 'clip'

		include Veto.model(Validator)

		def initialize params={}
			@params = params
		end

		def [] val
			send(val)
		end

		def bg
			params.key?(:bg) ? "##{params[:bg]}" : DEFAULT_BG
		end

		def fit
			params[:fit] || DEFAULT_FIT
		end

		def fm
			params[:fm]
		end

		def h
			params[:h].to_i if params.key?(:h)
		end

		def w
			params[:w].to_i if params.key?(:w)
		end

		def q
			params[:q].to_i if params.key?(:q)
		end

		def empty?
			params.empty?
		end

		private

		def params
			@params
		end
	end
end